#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlineedit.h>
#include <qprogressbar.h>

#include "MainHandler.h"
#include "ik_arm.h"

MainHandler::MainHandler()
{
	stop();
	
	connect(&timer, SIGNAL(timeout()), SLOT(updateADCs()));
	connect(&timer, SIGNAL(timeout()), SLOT(sendSpeeds()));
	
	connect(win.stop, SIGNAL(pressed()), SLOT(stop()));
	
	connect(win.fwd0, SIGNAL(pressed()), SLOT(fwd0()));
	connect(win.fwd0, SIGNAL(released()), SLOT(off0()));
	connect(win.rev0, SIGNAL(pressed()), SLOT(rev0()));
	connect(win.rev0, SIGNAL(released()), SLOT(off0()));
	
	connect(win.fwd1, SIGNAL(pressed()), SLOT(fwd1()));
	connect(win.fwd1, SIGNAL(released()), SLOT(off1()));
	connect(win.rev1, SIGNAL(pressed()), SLOT(rev1()));
	connect(win.rev1, SIGNAL(released()), SLOT(off1()));
	
	connect(win.fwd2, SIGNAL(pressed()), SLOT(fwd2()));
	connect(win.fwd2, SIGNAL(released()), SLOT(off2()));
	connect(win.rev2, SIGNAL(pressed()), SLOT(rev2()));
	connect(win.rev2, SIGNAL(released()), SLOT(off2()));
	
	connect(win.fwd3, SIGNAL(pressed()), SLOT(fwd3()));
	connect(win.fwd3, SIGNAL(released()), SLOT(off3()));
	connect(win.rev3, SIGNAL(pressed()), SLOT(rev3()));
	connect(win.rev3, SIGNAL(released()), SLOT(off3()));
	
	connect(win.fwd4, SIGNAL(pressed()), SLOT(fwd4()));
	connect(win.fwd4, SIGNAL(released()), SLOT(off4()));
	connect(win.rev4, SIGNAL(pressed()), SLOT(rev4()));
	connect(win.rev4, SIGNAL(released()), SLOT(off4()));
	
	connect(win.fwd5, SIGNAL(pressed()), SLOT(fwd5()));
	connect(win.fwd5, SIGNAL(released()), SLOT(off5()));
	connect(win.rev5, SIGNAL(pressed()), SLOT(rev5()));
	connect(win.rev5, SIGNAL(released()), SLOT(off5()));
	
	timer.start(100);
	win.show();
}

void MainHandler::updateADCs()
{
	unsigned int data[6];
	QString str;
	
	arm_get_adcs(data);
	
	str.sprintf("%03x", data[0]);
	win.adc0->setText(str);
	win.bar0->setProgress(data[0], 1023);
	
	str.sprintf("%03x", data[1]);
	win.adc1->setText(str);
	win.bar1->setProgress(data[1], 1023);
	
	str.sprintf("%03x", data[2]);
	win.adc2->setText(str);
	win.bar2->setProgress(data[2], 1023);
	
	str.sprintf("%03x", data[3]);
	win.adc3->setText(str);
	win.bar3->setProgress(data[3], 1023);
	
	str.sprintf("%03x", data[4]);
	win.adc4->setText(str);
	win.bar4->setProgress(data[4], 1023);
	
	str.sprintf("%03x", data[5]);
	win.adc5->setText(str);
	win.bar5->setProgress(data[5], 1023);
}

void MainHandler::sendSpeeds()
{
	arm_set_motors(motorSpeed);
	
#if 0
	for (int i = 0; i < NUM_MOTORS; i++)
		printf("%4d ", motorSpeed[i]);
	printf("\n");
#endif
}

void MainHandler::stop()
{
	for (int i = 0; i < NUM_MOTORS; i++)
	{
		motorSpeed[i] = 0;
	}
	
	sendSpeeds();
}

void MainHandler::fwd0()
{
	motorSpeed[0] = win.speed0->value();
	sendSpeeds();
}

void MainHandler::rev0()
{
	motorSpeed[0] = -win.speed0->value();
	sendSpeeds();
}

void MainHandler::off0()
{
	motorSpeed[0] = 0;
	sendSpeeds();
}

void MainHandler::fwd1()
{
	motorSpeed[1] = win.speed1->value();
	sendSpeeds();
}

void MainHandler::rev1()
{
	motorSpeed[1] = -win.speed1->value();
	sendSpeeds();
}

void MainHandler::off1()
{
	motorSpeed[1] = 0;
	sendSpeeds();
}

void MainHandler::fwd2()
{
	motorSpeed[2] = win.speed2->value();
	sendSpeeds();
}

void MainHandler::rev2()
{
	motorSpeed[2] = -win.speed2->value();
	sendSpeeds();
}

void MainHandler::off2()
{
	motorSpeed[2] = 0;
	sendSpeeds();
}

void MainHandler::fwd3()
{
	motorSpeed[3] = win.speed3->value();
	sendSpeeds();
}

void MainHandler::rev3()
{
	motorSpeed[3] = -win.speed3->value();
	sendSpeeds();
}

void MainHandler::off3()
{
	motorSpeed[3] = 0;
	sendSpeeds();
}

void MainHandler::fwd4()
{
	motorSpeed[4] = win.speed4->value();
	motorSpeed[5] = win.speed4->value();
	sendSpeeds();
}

void MainHandler::rev4()
{
	motorSpeed[4] = -win.speed4->value();
	motorSpeed[5] = -win.speed4->value();
	sendSpeeds();
}

void MainHandler::off4()
{
	motorSpeed[4] = 0;
	motorSpeed[5] = 0;
	sendSpeeds();
}

void MainHandler::fwd5()
{
	motorSpeed[4] = -win.speed5->value();
	motorSpeed[5] = win.speed5->value();
	sendSpeeds();
}

void MainHandler::rev5()
{
	motorSpeed[4] = win.speed5->value();
	motorSpeed[5] = -win.speed5->value();
	sendSpeeds();
}

void MainHandler::off5()
{
	motorSpeed[4] = 0;
	motorSpeed[5] = 0;
	sendSpeeds();
}
