#ifndef _MAIN_HANDLER_H_
#define _MAIN_HANDLER_H_

#include <qobject.h>
#include <qtimer.h>

#include "mainwindow.h"
#include "ik_arm.h"

class MainHandler: public QObject
{
	Q_OBJECT;
	
public:
	MainHandler();

	MainWindow *mainWindow() { return &win; }
	
protected:
	MainWindow win;
	QTimer timer;
	int motorSpeed[NUM_MOTORS];
	
protected slots:
	void updateADCs();
	void sendSpeeds();
	
	void stop();
	
	void fwd0();
	void rev0();
	void off0();

	void fwd1();
	void rev1();
	void off1();

	void fwd2();
	void rev2();
	void off2();

	void fwd3();
	void rev3();
	void off3();

	void fwd4();
	void rev4();
	void off4();

	void fwd5();
	void rev5();
	void off5();
};

#endif // _MAIN_HANDLER_H_
