#ifndef _IK_ARM_H_
#define _IK_ARM_H_

#define NUM_MOTORS		6
#define NUM_ADCS		6

/* Call this first.
 * This initializes the serial port called <device>.
 *
 * Returns nonzero on success.
 */
int arm_init(const char *device);

/* Call this to shut down the arm interface */
void arm_shutdown(void);

/* Sets all motor speeds.
 * data must be a pointer to NUM_MOTORS ints, each on the range [-16, 16].
 */
void arm_set_motors(int *data);

/* Gets the most recent ADC values.
 
 * data must point to NUM_ADCS unsigned ints which will receive
 * values on the range [0, 1023].
 */
void arm_get_adcs(unsigned int *data);

#endif /* _IK_ARM_H_ */
