#include <qapplication.h>
#include <qmessagebox.h>

#include "ik_arm.h"
#include "MainHandler.h"

int main(int argc, char *argv[])
{
	const char *device;
	QApplication app(argc, argv);
	
	if (argc == 2)
		device = argv[1];
	else device = "serial";
	
	if (!arm_init(device))
	{
		QMessageBox::critical(0, "IK Arm", "Can't initialize arm interface (serial port problem?)");
	
		return 1;
	}
	
	MainHandler handler;
	app.setMainWidget(handler.mainWindow());
	
	int ret = app.exec();
	
	arm_shutdown();
	
	return ret;
}
